﻿<%@ Page Language="C#" MasterPageFile="~/MasterPage.master" CodeFile="ClientSideEditing.aspx.cs"
    Inherits="C1GridView_ClientSideEditing" %>

<%@ Register Assembly="C1.Web.UI.Controls.4" Namespace="C1.Web.UI.Controls.C1GridView"
    TagPrefix="C1GridView" %>
<asp:Content ID="Content1" ContentPlaceHolderID="DescriptionPlaceHolder1" runat="Server">
    Add, edit, and delete records entirely on the client, making data entry faster and
    more intuitive.
</asp:Content>
<asp:Content ID="Content2" ContentPlaceHolderID="ContentPlaceHolder1" runat="Server">
    <script type="text/javascript">
/* <![CDATA[ */
        function pageLoad() {
        }

        function onBeforeCellEdit(grid, args) {
            if (args.get_cell().get_column().get_dataField() == "SupplierID") {
                args.set_handled(true);

                var contentCtrl = args.get_cell().get_contentControl();
                var cellValue = (typeof (contentCtrl.textContent) != "undefined")
                   ? contentCtrl.textContent.trim()
                   : contentCtrl.innerText.trim();

                var select = $get("<%= suppliersDDL.ClientID %>");
                select.value = args.get_value();
 
                args.get_cell().get_contentControl().innerHTML = "";
                args.get_cell().get_contentControl().appendChild(select);

                select.style.visibility = "visible";
            }
        }

        function onBeforeCellUpdate(grid, args) {
            var newValue = (args.get_cell().get_column().get_dataField() == "SupplierID")
                ? args.set_oldValue($get("<%= suppliersDDL.ClientID %>").value.toString())
                : args.get_cell().get_value(); // default value

            if (!newValue || newValue == "") {
                args.set_cancel(true);
                window.alert("Empty values are not allowed.");
                args.get_cell().get_contentControl().getElementsByTagName("input")[0].focus();
            }
        }

        function onAfterCellEdit(grid, args) {
            if (args.get_cell().get_column().get_dataField() == "SupplierID") {
                args.set_handled(true);
                var select = $get("<%= suppliersDDL.ClientID %>");

                select.style.visibility = "hidden";
                $get("ddlParent").appendChild(select);

                var contentCtrl = args.get_cell().get_contentControl();
                contentCtrl.innerHTML = "";

                if (typeof (contentCtrl.textContent) != "undefined") {
                    contentCtrl.textContent = args.get_value();
                }
                else {
                    contentCtrl.innerText = args.get_value();
                }
            }
        }
/* ]]> */
    </script>
    <br />
    <asp:UpdatePanel ID="UpdatePanel1" runat="server" UpdateMode="Conditional">
        <ContentTemplate>
            <div id="ddlParent">
                <asp:DropDownList runat="server" ID="suppliersDDL" DataTextField="CompanyName" DataValueField="SupplierID"
                    Style="visibility: hidden; width: auto" />
            </div>
            <C1GridView:C1GridView ID="C1GridView1" runat="server" DataKeyNames="ProductID" CallbackOptions="ClientEditing"
                ClientOnAfterCellEdit="onAfterCellEdit" ClientOnBeforeCellEdit="onBeforeCellEdit" 
                ClientOnBeforeCellUpdate="onBeforeCellUpdate" AllowClientEditing="true" VisualStylePath="~/C1WebControls/VisualStyles"
                AutoGenerateColumns="false" Width="100%"
                onrowcommand="C1GridView1_RowCommand">
                <RowHeader Visible="true" />
                <Columns>
                    <C1GridView:C1BoundField DataField="ProductID" HeaderText="ProductID" ReadOnly="true" />
                    <C1GridView:C1BoundField DataField="ProductName" HeaderText="ProductName" />
                    <C1GridView:C1BoundField DataField="SupplierID" HeaderText="SupplierID" />
                    <C1GridView:C1CheckBoxField DataField="Discontinued" HeaderText="Discontinued" />
                    <C1GridView:C1ButtonField CommandName="Delete" Text="Delete"></C1GridView:C1ButtonField>                    
                </Columns>
            </C1GridView:C1GridView>
        </ContentTemplate>
    </asp:UpdatePanel>
</asp:Content>
<asp:Content ID="Content3" ContentPlaceHolderID="ControlOptionsHolder1" runat="Server">
</asp:Content>
